/*
        Copyright (c) 1998, Apple Computer, Inc.
        All rights reserved.

        You may freely copy, distribute and reuse the code in this example.
        Apple disclaims any warranty of any kind, expressed or implied,
        as to its fitness for any particular use.
*/

#import <EOAccess/EOAccess.h>

@class FlatFileAdaptor;
@class FlatFileChannel;

#define ColumnNameKey @"name"
#define ColumnTypeKey @"type"

@interface FlatFileContext:EOAdaptorContext
{
    NSMutableDictionary *tableNameToInfoMap;
    NSMutableSet *dirtyTables;
    BOOL didAutoBegin;
}

- initWithFlatFileAdaptor:(FlatFileAdaptor *)adaptor;
- (void)dealloc;
- (EOAdaptorChannel *)createAdaptorChannel;
- (void)beginTransaction;
- (void)commitTransaction;
- (void)rollbackTransaction;

- (NSString *)path;
- (NSString *)rowSeparator;
- (NSString *)columnSeparator;
- (BOOL)useColumnHeaders;
- (NSStringEncoding)databaseEncoding;

- (NSMutableData *)dataForTable:(NSString *)tableName;
- (NSArray *)columnInfosForTable:(NSString *)tableName;
- (NSDictionary *)columnIndexMapForTable:(NSString *)tableName;
- (void)channel:(FlatFileChannel *)channel didDirtyTable:(NSString *)tableName;

- (BOOL)autoBeginTransaction;
- (BOOL)autoCommitTransaction;

@end
